image: docker:stable

variables:
  TOKEN: "__token__"
  CONTAINER_IMAGE: registry.gitlab.com/f.bergamin/2020_assignment1_calculator
  CONTAINER_RELEASE_IMAGE: registry.gitlab.com/f.bergamin/2020_assignment1_calculator:latest

stages:
    - build
    - verify
    - unit_test
    - integration_test
    - package
    - release
    - deploy


services:
  - docker:dind

build:
  stage: build

  script:
    - echo $CI_JOB_STAGE
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker build -t $CONTAINER_IMAGE .
    - docker push $CONTAINER_IMAGE


verify:
  image: $CONTAINER_IMAGE
  stage: verify
  services:
    - docker:dind
  script:
    - echo $CI_JOB_STAGE
    - flake8 src
    - flake8 Test
   


unit_test:
 
  image: $CONTAINER_IMAGE
  stage:
    unit_test
  script:
    - echo $CI_JOB_STAGE
    - pytest Test/unit_test
    

integration_test:
  image: $CONTAINER_IMAGE
  stage:
    integration_test
  services:
    - mysql:5.7
  script:
    - echo $CI_JOB_STAGE
    - pytest Test/integration_test


package:
  image: $CONTAINER_IMAGE
  stage: 
    package
  script:
    - echo $CI_JOB_STAGE
    - python setup.py sdist bdist_wheel
  artifacts:
    paths:
      - dist/**
      - calculator-project.egg-info/**
      - build/**

    
release:
  image: $CONTAINER_IMAGE
  dependencies:
    - package 
  stage:
    release
  script:
    - echo $CI_JOB_STAGE
    - TWINE_PASSWORD=${TOKEN_PASS} TWINE_USERNAME=${TOKEN} python -m twine upload --repository-url https://test.pypi.org/legacy/ --skip-existing dist/* 


deploy:
  image: $CONTAINER_IMAGE
  stage:
    deploy
  before_script:
    - apt-get update -qq
    - apt-get install -qq git
    # Setup SSH deploy keys
    - 'which ssh-agent || ( apt-get install -qq openssh-client )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    - mkdir -p ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
      
  script:
    - ssh -tt azureuser@52.149.68.33 "sudo apt update; python3 -m pip install --upgrade pip; python3 -m pip install -i https://test.pypi.org/simple/ calculator-project==0.0.9"



  
